<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onMount } from 'svelte';
	import { streamerApi } from '$lib/requests/requests';
	import { page } from '$app/stores';
	import type { Streamer } from '$lib/api';
	import { ws } from '$lib/config';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	// One might use this widget with a GET param for the streamer ID
	// ?streamer=1

	// This URI should work : http://localhost:5173/example?streamer=1

	let streamerId = $page.url.searchParams.get('streamer');
	let streamer: Streamer | undefined;

	// Type for data
	type StreamerData = {
		viewCount: number;
		isLive: boolean;
		timestamp: number;
		pot: number;

		// Optionnal
		viewCountArray?: null | string[];
	};

	let streamerData: StreamerData | undefined;

	onMount(async () => {
		try {
			let resp = await streamerApi().getStreamerByIdStreamersStreamerIdGet(streamerId);
			streamer = resp.data;
		} catch {
			// Redirect to 404
			// window.location.href = '/404';
		}

		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `streamers.${streamerId}.*` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);

			console.log('Received update', data);

			switch (data.r) {
				case `streamers.${streamerId}.live`:
					if (!streamerData) streamerData = { viewCount: 0, isLive: false, timestamp: 0, pot: 0 };
					streamerData.isLive = data.d.isLive;
					streamerData.timestamp = parseInt(data.d.timestamp);

					streamerData.viewCount = data.d.viewCount;

					// Split two by two making sure that the first one is the one that is not two by two
					let str = streamerData.viewCount.toString();
					streamerData.viewCountArray = str.split('');
					console.log(streamerData.viewCountArray);
					break;
				case `streamers.${streamerId}.pot`:
					if (!streamerData) streamerData = { viewCount: 0, isLive: false, timestamp: 0, pot: 0 };
					streamerData.pot = data.d.pot;
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});
</script>

{#if streamerData}
	<div class="bg-gray-100 rounded-lg p-4 flex flex-col justify-center items-center">
		<h1 class="text-3xl font-bold underline">Hello world!</h1>
		<p class="text-gray-500">Streamer ID: {streamerId}</p>

		<div class="grid grid-flow-row text-center">
			<span class="text-gray-500">Viewers count :</span>
			<div class="text-gray-500">
				{#each streamerData.viewCountArray ?? [] as digit}
					<span class="smart-countdown font-mono mt-1">
						<span style="--value:{digit};"></span>
					</span>
				{/each}
			</div>
		</div>

		<!-- <p class="text-gray-500">Is live: {streamerData.isLive ? 'Yes' : 'No'}</p>
		<p class="text-gray-500">Pot: {streamerData.pot}</p> -->
	</div>
{:else}
	<div class="bg-gray-100 rounded-lg p-4 flex flex-col justify-center items-center">
		<h1 class="text-3xl font-bold underline">Hello world!</h1>
		<p class="text-gray-500">Streamer ID: {streamerId}</p>
	</div>
{/if}

<style>
	.smart-countdown {
		line-height: 1em;
	}
	.smart-countdown {
		display: inline-flex;
	}
	.smart-countdown > * {
		height: 1em;
		display: inline-block;
		overflow-y: hidden;
	}
	.smart-countdown > *:before {
		position: relative;
		content: '0\A 1\A 2\A 3\A 4\A 5\A 6\A 7\A 8\A 9\A';
		white-space: pre;
		top: calc(var(--value) * -1em);
		text-align: center;
		transition: all 1s cubic-bezier(1, 0, 0, 1);
	}
</style>
